//Paper 1



//Table 3 - average leverage.
//Nr. of comp. was calculated "manually" from excel-file.
use "Paper1/Paper1-Stage1-OLSandGMM.dta"
sum leverage if france==1
sum leverage if germany==1
sum leverage if gb==1
sum leverage if italy==1
sum leverage if spain==1



//Table 4
correl leverage  profitability size tangibility ndt avgindlev cashflow firmage investments



//Table 5
sum leverage profitability size tangibility ndt avgindlev cashflow firmage investments



//Table 6
//OLS
xtset nr year, yearly
regress leverage l.leverage l.profitability l.size l.tangibility l.growth l.ndt ///
avgindlev germany spain italy france

//GMM
xtabond2 leverage L.leverage L.profitability L.size  L.tangibility L.growth L.ndt ///
L.avgindlev germany spain italy france,  gmm(L.leverage L.profitability L.size ///
L.growth L.ndt L.tangibility) iv(L.avgindlev germany spain italy france) twostep robust small orthog



//Table 7 (and A6)
use Paper1/Paper1-Stage2-allcompanies_countries.dta
regress change deviation
regress changegmm deviationgmm
regress changebc deviationbc



//Table8
//PROFITABILITY
use "Paper1/profitability.dta"
//OLS
regress change deviation if quantile==1
regress change deviation if quantile==4

//GMM
regress changegmm deviationgmm if quantile==1
regress changegmm deviationgmm if quantile==4

//BC
regress changebc deviationbc if quantile==1
regress changebc deviationbc if quantile==4

//CASHFLOW
use "Paper1/cashflow.dta"
//OLS
regress change deviation if quantile==1
regress change deviation if quantile==4

//GMM
regress changegmm deviationgmm if quantile==1
regress changegmm deviationgmm if quantile==4

//BC
regress changebc deviationbc if quantile==1
regress changebc deviationbc if quantile==4

//SIZE
use "Paper1/size.dta"
//OLS
regress change deviation if quantile==1
regress change deviation if quantile==4

//GMM
regress changegmm deviationgmm if quantile==1
regress changegmm deviationgmm if quantile==4

//BC
regress changebc deviationbc if quantile==1
regress changebc deviationbc if quantile==4

//AGE
use "Paper1/age.dta"
//OLS
regress change deviation if quantile==1
regress change deviation if quantile==4

//GMM
regress changegmm deviationgmm if quantile==1
regress changegmm deviationgmm if quantile==4

//BC
regress changebc deviationbc if quantile==1
regress changebc deviationbc if quantile==4

//INVESTMENTS
use "Paper1/investments.dta"
//OLS
regress change deviation if quantile==1
regress change deviation if quantile==4

//GMM
regress changegmm deviationgmm if quantile==1
regress changegmm deviationgmm if quantile==4

//BC
regress changebc deviationbc if quantile==1
regress changebc deviationbc if quantile==4



//Table 9 (and table A8)
use "Paper1/Paper 1 - stage 2 - combination variables (table 10).dta"
//LARGECOSTS1
regress change deviation if largecosts1==1
regress changegmm deviationgmm if largecosts1==1
regress changebc deviationbc if largecosts1==1

//LARGECOSTS1
regress change deviation if largecosts2==1
regress changegmm deviationgmm if largecosts2==1
regress changebc deviationbc if largecosts2==1

//SMALLCOSTS1
regress change deviation if smallcosts1==1
regress changegmm deviationgmm if smallcosts1==1
regress changebc deviationbc if smallcosts1==1

//SMALL&YOUNG1
regress change deviation if smallyoung1==1
regress changegmm deviationgmm if smallyoung1==1
regress changebc deviationbc if smallyoung1==1

//SMALL&YOUNG2
regress change deviation if smallyoung2==1
regress changegmm deviationgmm if smallyoung2==1
regress changebc deviationbc if smallyoung2==1

//OLD&LARGE1
regress change deviation if oldlarge1==1
regress changegmm deviationgmm if oldlarge1==1
regress changebc deviationbc if oldlarge1==1

//OLD&LARGE2
regress change deviation if oldlarge2==1
regress changegmm deviationgmm if oldlarge2==1
regress changebc deviationbc if oldlarge2==1



//Table 10 (and A9)

//PROFITABILITY
use "Paper1/profitability.dta"
//OLS
regress change deviation if quantile==1 & o_ubyfirmnr== -1
regress change deviation if quantile==1 & o_ubyfirmnr== 1
regress change deviation if quantile==4 & o_ubyfirmnr== -1
regress change deviation if quantile==4 & o_ubyfirmnr== 1

//GMM
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== 1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== 1

//BC
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== 1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== 1

//CASHFLOW
use "Paper1/cashflow.dta"
//OLS
regress change deviation if quantile==1 & o_ubyfirmnr== -1
regress change deviation if quantile==1 & o_ubyfirmnr== 1
regress change deviation if quantile==4 & o_ubyfirmnr== -1
regress change deviation if quantile==4 & o_ubyfirmnr== 1

//GMM
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== 1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== 1

//BC
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== 1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== 1

//SIZE
use "Paper1/size.dta"
//OLS
regress change deviation if quantile==1 & o_ubyfirmnr== -1
regress change deviation if quantile==1 & o_ubyfirmnr== 1
regress change deviation if quantile==4 & o_ubyfirmnr== -1
regress change deviation if quantile==4 & o_ubyfirmnr== 1

//GMM
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== 1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== 1

//BC
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== 1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== 1

//AGE
use "Paper1/age.dta"
//OLS
regress change deviation if quantile==1 & o_ubyfirmnr== -1
regress change deviation if quantile==1 & o_ubyfirmnr== 1
regress change deviation if quantile==4 & o_ubyfirmnr== -1
regress change deviation if quantile==4 & o_ubyfirmnr== 1

//GMM
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== 1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== 1

//BC
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== 1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== 1

//INVESTMENTS
use "Paper1/investments.dta"
//OLS
regress change deviation if quantile==1 & o_ubyfirmnr== -1
regress change deviation if quantile==1 & o_ubyfirmnr== 1
regress change deviation if quantile==4 & o_ubyfirmnr== -1
regress change deviation if quantile==4 & o_ubyfirmnr== 1

//GMM
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==1 & o_ubyfirmnr== 1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== -1
regress changegmm deviationgmm if quantile==4 & o_ubyfirmnr== 1

//BC
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==1 & o_ubyfirmnr== 1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== -1
regress changebc deviationbc if quantile==4 & o_ubyfirmnr== 1



//Table A1
use "Paper1/Paper 1 - quartilestatistics.dta"
sum leverage profitability size tangibility growth ndt avgindlev cashflow if cfquart==1
sum leverage profitability size tangibility growth ndt avgindlev cashflow if cfquart==2
sum leverage profitability size tangibility growth ndt avgindlev cashflow if cfquart==3
sum leverage profitability size tangibility growth ndt avgindlev cashflow if cfquart==4

//Table A2
sum leverage profitability size tangibility growth ndt avgindlev if profquart==1
sum leverage profitability size tangibility growth ndt avgindlev if profquart==2
sum leverage profitability size tangibility growth ndt avgindlev if profquart==3
sum leverage profitability size tangibility growth ndt avgindlev if profquart==4

//Table A3
sum leverage profitability size tangibility growth ndt avgindlev firmage if agequart==1
sum leverage profitability size tangibility growth ndt avgindlev firmage if agequart==2
sum leverage profitability size tangibility growth ndt avgindlev firmage if agequart==3
sum leverage profitability size tangibility growth ndt avgindlev firmage if agequart==4

//Table A4
sum leverage profitability size tangibility growth ndt avgindlev if sizequart==1
sum leverage profitability size tangibility growth ndt avgindlev if sizequart==2
sum leverage profitability size tangibility growth ndt avgindlev if sizequart==3
sum leverage profitability size tangibility growth ndt avgindlev if sizequart==4

//Table A5
sum leverage profitability size tangibility growth ndt avgindlev investments if invquart==1
sum leverage profitability size tangibility growth ndt avgindlev investments if invquart==2
sum leverage profitability size tangibility growth ndt avgindlev investments if invquart==3
sum leverage profitability size tangibility growth ndt avgindlev investments if invquart==4
