clear
set memory 500m
set matsize 800 //3000
set linesize 255
set more off
log using "bootstrapMaster.smcl", replace
set more off // stich off for set more option
local sy = 2002 // start of sample period
local ey = 2009 // end of sample period
local tsy = `sy'+1
local tey = `ey'
local tobs = 4 //need more than 3 obs for a company
local vary "leverage"
local varly "LLEVERAGE"
local exogvar "LPROF LSIZE LNDT LAVGINDLEV LGROWTH LTANG GERMANY SPAIN ITALY FRANCE"  //"LEBIT_TA LMB LDEP_TA LlnTA LFA_TA LRD_DUM LRD_TA LInd_Median_MDR"
local td "TD2003 TD2004 TD2005 TD2006 TD2007 TD2009"  //"TD1969 TD1970 TD1971 TD1972 TD1973 TD1974 TD1975 TD1976 TD1977 TD1978 TD1979 TD1980 TD1981 TD1982 TD1983 TD1984 TD1985 TD1986 TD1987 TD1988 TD1989 TD1990 TD1991 TD1992 TD1993 TD1994 TD1995 TD1996 TD1997 TD1998 TD1999 TD2000 TD2001 TD2002 TD2003 TD2004 TD2005 TD2006"
scalar cval = 0.001
scalar maxiter = 100
scalar nb = 2000

use "paper1 - stage 1 BC.dta", clear // load dataset
tsset nr year, yearly //gvkeym fyear, yearly // time-series setting
drop if (year < `sy')|(year > `ey') // sample period
by nr: ge nobs = _N 
drop if nobs < `tobs' // drop individuals if their time-observations are less than 5
forvalues i = `sy'/`ey' { // generate time dummies
	ge TD`i' = 0
	replace TD`i' = 1 if year == `i'
}
ge LLEVERAGE = L.leverage // lagged MDR
//ge LBDR = L.BDR // lagged BDR
ge LPROF = L.profitability // lagged EBIT_TA
ge LSIZE = L.size // lagged MB
//ge LGROWTH = L.growth
ge LNDT = L.ndt // lagged RD_TA
ge LAVGINDLEV = L.avgindlev // lagged FA_TA
ge LTANG = L.tangibility
ge LGROWTH = L.growth // lagged lnTA
ge GERMANY = germany // lagged RD_DUM
ge SPAIN = spain // lagged RD_DUM
ge ITALY = italy // lagged RD_DUM
ge FRANCE = france // lagged RD_DUM
//ge LInd_Median_MDR = L.Ind_Median_MDR // lagged Ind_Median_MDR

sort nobs nr year
mata: bdpdfex("nr","nobs","`vary'","`varly'","`exogvar'","`td'","cval","nb","maxiter")

mata
mata clear
end

log close