clear
set memory 500m
set matsize 800 //3000
set linesize 255
set more off
log using "Paper2_leverage_long.smcl", replace
set more off 
local sy = 2002 // start of sample period
local ey = 2009 // end of sample period
local tsy = `sy'+1
local tey = `ey'
local tobs = 3 //need 3 obs for a company
local vary "lon"  //lon because long is reserved in Stata
local varly "LLON"
local exogvar "APROF ASIZE ATANG AGROWTH ANDT AINDMEAN AINF AGDP ACORR ALAW AINVPROT ASTCK ATAX ADEV"
local td "TD2002 TD2003 TD2004 TD2005 TD2006 TD2007 TD2009"
scalar cval = 0.005
scalar maxiter = 100
scalar nb = 1000

use "Paper2_all_long.dta", clear // load dataset
tsset nr year, yearly
drop if (year < `sy')|(year > `ey') // sample period
by nr: ge nobs = _N 
drop if nobs < `tobs' 
forvalues i = `sy'/`ey' { // generate time dummies
	ge TD`i' = 0
	replace TD`i' = 1 if year == `i'
}
ge LLON = L.lon
ge APROF = profitability
ge ASIZE = size
ge ATANG = tangibility
ge AGROWTH = growth
ge ANDT = ndt
ge AINDMEAN = avgindlev
ge AINF = inflation
ge AGDP = gdpgrowth
ge ACORR = corruption
ge ALAW = ruleoflaw
ge AINVPROT = invprotection
ge ASTCK = stock
//ge BOND = bond
ge ATAX = taxgain
ge ADEV = deveconomy

sort nobs nr year
mata: bdpdfex("nr","nobs","`vary'","`varly'","`exogvar'","`td'","cval","nb","maxiter")

mata
mata clear
end

log close
