//
//	data must be sorted by nobs and id
//=============================================================================
version 10.0
mata:
void bdpdfex(string scalar var_id,var_n,var_y,var_ly,var_x,var_d,var_c,var_nb,var_mxiter) {
	real colvector b,b0,bb,bboot,bias,bm,ly,lyb,lybar,lybarh,lybbar,lybh,lyh,lyy,lyyb,m,nid,nidh,nobs,nobs0,nobsh,sb,sqrtmh,szy,szyb,tb,u,ub,ubh,ubhi,unid,unidh,unobs,v,vb,vbh,vbhi,vrb,y,y0,y0h,yb,ybar,ybarh,ybh,ybhi,yh,yy,yyb,b2,lb,s2b12,s2b2,slb,tlb
	real rowvector bsample,mz,xbarh,dbarh,zzh
	real matrix d,dbar,dd,dh,dhi,iszz,iszzb,tmp,x,xbar,xh,xhi,xx,z,zb,zbar,zbbar,zz,zzb,s2b
	real scalar boot,c,c0,cboot,crit,er,erh,erhi,flag,h,iter,j,k,l,lybbarh,mxiter,my,n,nb,nh,nt,p,sc,sr,srh,srhi,sv,tc,th,y0hi,ybbarh,s2v,s2c,b1,s2b1

	printf("read data\n")
//
//	read data
//=============================================================================	
	st_view(nid=.,.,(var_id)) // individual id: NTx1
	st_view(nobs=.,.,(var_n)) // nobs id: NTx1
	st_view(y=.,.,(var_y)) // dependent variable, y(i,t): NTx1
	st_view(ly=.,.,(var_ly)) // lagged dependent variable, y(i,t-1): NTx1
	st_view(x=.,.,tokens(var_x)) // exogeneous variable, x(i,t): NTxK
	st_view(d=.,.,tokens(var_d)) // time dummy variable, D(i,t): NTxL
	crit = st_numscalar(var_c) // tolerence level
	nb = st_numscalar(var_nb) // number of bootstrapping
	mxiter = st_numscalar(var_mxiter) // number of maximum iteration
	k = cols(x) // number of regressor
	l = cols(d) // number of time dummies
	unid = uniqrows(nid)
	n = rows(unid) // number of individuals by id
	unobs = uniqrows(nobs)
	p = rows(unobs) // number of groups by nobs

	printf("generate initial values: y(i,1)\n")
//
//	initial values of y(i,1)
//=============================================================================
	y0 = J(n,1,0) // Nx1
	nobs0 = J(n,1,0) // Nx1
	for (h=1; h<=n; h++) {
		yh = select(y,(nid:==unid[h])) // T(h)x1
		nobsh = select(nobs,(nid:==unid[h])) // T(h)x1
		y0[h] = yh[1] // scalar
		nobs0[h] = nobsh[1] // scalar
	}

	printf("remove missing values\n")
//
//	remove missing values
//=============================================================================
	tmp = (nid,nobs,y,ly,x,d)
	tmp = sort(tmp,(2,1))
	tmp = select(tmp,rowmin(tmp:!=.))
	nid = tmp[.,1] // (NT-N)x1
	nobs = tmp[.,2] // (NT-N)x1
	y = tmp[.,3] // (NT-N)x1
	ly = tmp[.,4] // (NT-N)x1
	x = tmp[.,5::k+4] // (NT-N)xK
	d = tmp[.,k+5::k+l+4] // (NT-N)xL
	z = (ly,x,d) // (NT-N)x(1+K+L)

	printf("within estimation\n")
//
//	within estimation
//=============================================================================	
	nt = rows(y) // NT* = NT-N
	ybar = J(nt,1,0) // NT*x1
	lybar = J(nt,1,0) // NT*x1
	xbar = J(nt,k,0) // NT*xK
	dbar = J(nt,l,0) // NT*xL
	er = 0
	for (h=1;h<=n;h++) {
		yh = select(y,(nid:==unid[h])) // T(h)*x1, T(h)* = T(h)-1
		lyh = select(ly,(nid:==unid[h])) // T(h)*x1
		xh = select(x,(nid:==unid[h])) // T(h)*xK
		dh = select(d,(nid:==unid[h])) // T(h)*xL
		th = rows(yh) // T(h)*
		sr = er+1
		er = sr+th-1
		ybarh = mean(yh) // scalar
		lybarh = mean(lyh) // scalar
		xbarh = mean(xh) // 1xK
		dbarh = mean(dh) // 1xL
		ybar[sr::er] = ybarh*J(th,1,1) // T(h)*x1
		lybar[sr::er] = lybarh*J(th,1,1) // T(h)*x1
		xbar[sr::er,.] = J(th,1,1)#xbarh // T(h)*xK
		dbar[sr::er,.] = J(th,1,1)#dbarh // T(h)*xL
	}
	zbar = (lybar,xbar,dbar) // NT*x(1+K+L)
	yy = y-ybar // NT*x1
	lyy = ly-lybar // NT*x1
	xx = x-xbar // NT*xK
	dd = d-dbar // NT*xL
	zz = (lyy,xx,dd) // NT*x(1+K+L)
	iszz = invsym(zz'zz)
	szy = zz'yy
	b0 = iszz*szy
	my = mean(y) // scalar
	mz = mean(z) // 1x(1+K+L)
	c0 = my - mz*b0 // constant
	b0 = (b0\c0) // (1+K+L+1)x1

	printf("generate rescaling term\n")	
//
//	rescaling term
//=============================================================================	
	m = J(nt,1,0) // m(i,t), NT*x1
	er = 0
	for (h=1;h<=n;h++) {
		zzh = select(zz,(nid:==unid[h])) // T(h)*x(1+K+L)
		th = rows(zzh) // T(h)*
		sr = er+1 
		er = sr+th-1
		m[sr::er] = diagonal(I(th)-zzh*iszz*zzh') // T(h)*x1
	}

	printf("start bootstrapping\n")
//
//	Bootstrap Within Estimation
//=============================================================================
	iter = 0
	flag = 1
	bb = b0 // (1+K+L+1)x1
	while (flag) {
		ub = 	ybar - zbar*bb[1::1+k+l] - bb[1+k+l+1]*J(nt,1,1) // fixed effect, NT*x1
		vb = y - z*bb[1::1+k+l] - bb[1+k+l+1]*J(nt,1,1) - ub // residual, NT*x1
		vrb = J(nt,1,0) // rescaled residuals
		er = 0
		for (h=1;h<=n;h++) {
			vbh = select(vb,(nid:==unid[h]))
			sqrtmh = sqrt(select(m,(nid:==unid[h])))
			th = rows(vbh)
			sr = er+1
			er = sr+th-1
			vrb[sr::er] = sqrt(th/(th-1))*(vbh:/sqrtmh-(1/th)*sum(vbh:/sqrtmh)*J(th,1,1)) // T(h)*x1
		}
		
//
//	bootstrap sampling
//=============================================================================
		bsample = J(nb,1+k+l+1,0)
		for (boot=1;boot<=nb;boot++) {
			printf("%9.2f : %9.2f th bootstrapping\n",iter,boot)

//
//	step 1: sampling
//=============================================================================			
			yb = J(nt,1,0) // {N(h)*T(h)*}x1
			lyb = J(nt,1,0) // {N(h)*T(h)*}x1
			erh = 0
			for (h=1;h<=p;h++) {
				th = unobs[h] // T(h)
				nidh = select(nid,(nobs:==th)) // (N(h)*T(h))x1
				unidh = uniqrows(nidh) // N(h)x1
				nh = rows(unidh) // N(h)
				vbh = select(vb,(nobs:==th)) // (N(h)*T(h)*)x1
				ubh = select(ub,(nobs:==th)) // (N(h)*T(h)*)*x1
				y0h = select(y0,(nobs0:==th)) // N(h)*x1
				xh = select(x,(nobs:==th)) // (N(h)*T(h)*)xK
				dh = select(d,(nobs:==th)) // (N(h)*T(h)*)xL
				srh = erh+1
				erh = srh+nh*(th-1)-1
				vbh = colshape(vbh,nh) // T(h)*xN(h)
				vbh = vec(vbh[.,ceil(nh*uniform(nh,1))]) // (N(h)xT(h)*)x1
				ybh = J(nh*(th-1),1,0) // y(i,t), (N(h)xT(h)*)x1
				lybh = J(nh*(th-1),1,0) // y(i,t-1), (N(h)xT(h)*)x1
				erhi = 0
				for (i=1;i<=nh;i++) {
					srhi = erhi+1
					erhi = srhi+(th-1)-1
					vbhi = select(vbh,(nidh:==unidh[i])) // T(h)*x1
					ubhi = select(ubh,(nidh:==unidh[i])) // T(h)*x1
					xhi = select(xh,(nidh:==unidh[i])) // T(h)*xK
					dhi = select(dh,(nidh:==unidh[i])) // T(h)*xL
					y0hi = y0h[i] // sclar
					ybhi = J(th,1,0) // T(h)x1
					j = 1
						ybhi[j] = y0hi
					for (j=2;j<=th;j++) {
						ybhi[j] = bb[1]*ybhi[j-1] + xhi[j-1,.]*bb[2::1+k] + dhi[j-1,.]*bb[k+2::1+k+l] + bb[1+k+l+1] + ubhi[j-1] + vbhi[j-1]
					}
					ybh[srhi::erhi] = ybhi[2::th]
					lybh[srhi::erhi] = ybhi[1::th-1]
				}
				yb[srh::erh] = ybh
				lyb[srh::erh] = lybh
			}
			zb = (lyb,x,d)
			
//
//	step 2: within estimation
//=============================================================================	
			ybbar = J(nt,1,0)
			lybbar = J(nt,1,0)
			er = 0
			for (h=1;h<=n;h++) {
				ybh = select(yb,(nid:==unid[h])) // T(h)*x1
				lybh = select(lyb,(nid:==unid[h])) // T(h)*x1
				th = rows(ybh) // T(h)*
				sr = er+1
				er = sr+th-1
				ybbarh = mean(ybh) // scalar
				lybbarh = mean(lybh) // scalar
				ybbar[sr::er] = ybbarh*J(th,1,1) // T(h)*x1
				lybbar[sr::er] = lybbarh*J(th,1,1) // T(h)*x1
			}
			zbbar = (lybbar,xbar,dbar) // NT*x(1+K+L)
			yyb = yb-ybbar // NTx1
			lyyb = lyb-lybbar // NTx1
			zzb = (lyyb,xx,dd) // NTx(1+K+L)
			iszzb = invsym(zzb'zzb) // (1+K+L)x(1+K+L)
			szyb = zzb'yyb
			bboot = iszzb*szyb
			cboot = mean(yb) - mean(zb)*bboot // constant
			bsample[boot,.] = (bboot',cboot) // 1x(1+K+L+1)		
		}
		bm = mean(bsample)' // (1+K+L+1)x1
		bias = b0-bm // (1+K+L+1)x1
		printf("\n")
		(b0,bm,bias,bb)
		printf("\n")
		if (colmax(abs(bias))<crit|iter==mxiter) {
			b = bb
			flag = 0
		}
		else {
			bb = bb + bias
			iter++
		}
	}

	printf("final estimation\n")

//
//	final estimation
//=============================================================================	
	c = b[1+k+l+1]
	b = b[1::1+k+l]
	u = ybar - zbar*b - c*J(nt,1,1)
	v = y - z*b - c*J(nt,1,1) - u
	s2v = v'v/(nt-n-k-l-1) // variance of residual,scalar
	sv = sqrt(v'v/(nt-n-k-l-1)) // standard deviation of residual
	s2b = s2v*iszz // variance of regressors, (1+K+L)x(1+K+L)
	sb = sqrt(diagonal(s2b)) // standard errors of regressors, (1+K+L)x1
	tb = b:/sb // t-ratio of regressors, (1+K+L)x1
	s2c = s2v*(mz*iszz*mz'+1/nt) // variance of constant, scalar
	sc = sqrt(s2c) // standard error of constant, scalar
	tc = c:/sc // t-ratio of constant, scalar
	(b,sb,tb\c,sc,tc)

	printf("long-run parameters\n")
//
//	long-run parameter
//=============================================================================
	b1 = b[1] // estimate of lagged dependent variable, scalar
	b2 = b[2::k+1] // estimates of exogeneous variables, Kx1
	lb = b2:/(1-b1) // long-run parameter, Kx1
	s2b12 = diagonal(s2b) // (K+1)x1
	s2b1 = s2b12[1] // variance of lagged dependent variable Var(r), scalar
	s2b2 = s2b12[2::k+1] // variance of exogeneous variable {Var(b1),...,Var(bk)}, Kx1
	s2b12 = s2b[2::k+1,1] // covariance terms {Cov(r,b1),...,Cov(r,bk)}, Kx1
	slb = sqrt((1/(1-b1)^2)*s2b2 + ((b2:^2):/(1-b1)^4)*s2b1 + (2*b2:/(1-b1)^3):*s2b12) // variance of long-run parameters by Delta Methods, Kx1
	tlb = lb:/slb // t-ratio of long-run parameters, Kx1
	(lb,slb,tlb)
}
mata mosave bdpdfex(),replace
end
